var req;
var dicurl = "dic.pl?word=";
var fetchurl = "fetch.pl?word=";
var helpurl = "help.txt";

var fetchflag = false;

function Initialize() {
  try {
    req = new ActiveXObject("Msxml2.XMLHTTP");
  } catch(e) {
    try {
      req = new ActiveXObject("Microsoft.XMLHTTP");
    } catch(E) {
      req = null;
    }
  }

  if(!req && typeof XMLHttpRequest != "undefined") {
    req = new XMLHttpRequest();
  }
}

function AutoComplete() {
  var word = document.form.word.value;
  if(fetchflag) return false;
  
  if(word == "") {
    document.getElementById("result").style.display = "none";
    return false;
  }
  
  Initialize();

  if(req) {
    var date = new Date();
    var rand = Math.floor(Math.random()*1000);
    req.onreadystatechange = AutoCompleteProcess;
    req.open("GET", dicurl+word+"&d="+date+"&r="+rand, true);
    req.send(null);
  }

  return false;
}

function AutoCompleteProcess() {
  if(req.readyState == 4 && req.status == 200) {
    document.getElementById("result").style.display = "block";

    req.responseText != "" ?
      document.getElementById("result").innerHTML = req.responseText
    : Error("There were no cache for your search query<br />Press Enter for search word");
  }
}

function FetchDictionary() {
  var word = document.form.word.value;
  if(word == "") {
    document.getElementById("result").style.display = "none";
    return false;
  }

  Initialize();
  if(req) {
    fetchflag = true;
    ShowLoading();
    var date = new Date();
    req.onreadystatechange = FetchProcess;
    req.open("GET", fetchurl+word+"&d="+date, true);
    req.send(null);
  }
  return false;
}

function FetchProcess() {
  if(req.readyState == 4) {
    fetchflag = false;
    
    if(req.status == 200) {
      req.responseText == "0" ? Error("There are no result for your search query") : AutoComplete();
    }
  }
}

function Help() {
  Initialize();
  if(req) {
    req.onreadystatechange = HelpProcess;
    req.open("GET", helpurl, true);
    req.send(null);
  }
  return false;
}

function HelpProcess() {
  if(req.readyState == 4 && req.status == 200) {
    document.getElementById("result").style.display = "block";
    document.getElementById("result").innerHTML = req.responseText;
  }
}
function ShowLoading() {
  document.getElementById("result").style.display = "block";
  document.getElementById("result").innerHTML = "<span class=\"message\">Searching Dictionary...</span>";
}

function Error(msg) {
  document.getElementById("result").style.display = "block";
  document.getElementById("result").innerHTML = "<span class=\"error\">"+msg+"</span>";
}

window.onload = function(e) {
  document.getElementById("result").style.display = "none";
  document.form.onsubmit = FetchDictionary;
  document.form.word.onkeyup = AutoComplete;
  document.getElementById("help").onclick = Help;
}
